﻿using System;

namespace IRaCIS.Application.Contracts
{
    public class CalculateNeededDTO
    {
        public Guid Id { get; set; }
        public Guid DoctorId { get; set; }
        public string YearMonth { get; set; } = String.Empty;
        public bool IsLock { get; set; }
    }

    public class DoctorPrice
    {
        public decimal? AdjustmentMultiple { get; set; }

        public Guid? DoctorId { get; set; }

        public Guid? TrialId { get; set; }

        public bool? IsNewTrial { get; set; }

        public int? Training { get; set; }

        public int? RefresherTraining { get; set; }

        public int? Timepoint { get; set; }

        public int? Timepoint48H { get; set; }

        public int? Timepoint24H { get; set; }

        public int? Adjudication { get; set; }

        public int? Adjudication48H { get; set; }

        public int? Adjudication24H { get; set; }

        public int? Global { get; set; }


        public int? Downtime { get; set; }
    }
}
