﻿using System;

namespace IRaCIS.Core.Application.Contracts.Dicom.DTO
{
    public class ImageShareCommand
    {
        public Guid TrialId { get; set; }
        public Guid SiteId { get; set; }
        public Guid SubjectId { get; set; }
        public Guid? StudyId { get; set; }

        public DateTime? ExpireTime { get; set; }

        public string Password { get; set; } = string.Empty;
    }

    public class ResourceInfo
    {
        public Guid StudyId { get; set; }

        public string Token { get; set; } = string.Empty;
    }
}