﻿using System;

namespace IRaCIS.Core.Application.Contracts.Dicom.DTO
{
    public class StudyStatusDetailDTO
    {
        public Guid Id { get; set; }
        public Guid StudyId { get; set; }
        public int Status { get; set; }
        public string OptUserName { get; set; }=string.Empty;
        public DateTime OptTime { get; set; }
        public string Note { get; set; } = string.Empty;
    }

    public class StudyStatusDetailCommand
    {
        public Guid StudyId { get; set; }

        public int Status { get; set; }

        public DateTime? DeadlineTime { get; set; }
        public string Note { get; set; } = string.Empty;

        //QA不通过的时候传递参数
        public string QAComment { get; set; } = string.Empty;
    }
}
