﻿namespace IRaCIS.Application.Contracts
{

    public class DictionaryTreeNode
    {
        public Guid Id { get; set; }
        public string KeyName { get; set; } = string.Empty;
        public string Type { get; set; } = string.Empty;
        public List<DictionaryTreeNode> Children { get; set; }=new List<DictionaryTreeNode>();
    }

    public class MenuTreeNodeSelect: MenuCommand
    {
       
        public List<MenuTreeNodeSelect> Children { get; set; } = new List<MenuTreeNodeSelect>();
        public bool IsSelect { get; set; } = false;
    }


    public class MenuTreeNode : MenuCommand
    {

        public List<MenuTreeNode> Children { get; set; } = new List<MenuTreeNode>();
    }
   
}