﻿using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("Message")]
    public class Message : Entity
    {
        public Guid ToDoctorId { get; set; }
        public Guid FromUserId { get; set; }
        public string Title { get; set; } = string.Empty;
        public string Content { get; set; } = string.Empty;
        public DateTime MessageTime { get; set; }
        public bool HasRead { get; set; }
        public string Memo { get; set; } = string.Empty;

    }
}
