﻿using IRaCIS.Core.Domain.Share;
using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("VerificationCode")]
    public class VerificationCode:Entity, IAuditAdd
    {
        //public Guid Id { get; set; }

        public Guid UserId { get; set; } = Guid.Empty;

        //验证码
        public string Code { get; set; }

        //什么类型的验证码   邮箱|手机

        public VerifyType CodeType { get; set; }

        public bool HasSend { get; set; }


        //发送的邮箱或者手机
        public string EmailOrPhone { get; set; }


        //过期时间
       public DateTime ExpirationTime { get; set; }

        public Guid CreateUserId { get; set; }
        public DateTime CreateTime { get; set; }
    }
}