﻿using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    public class TrialExperienceCriteria:Entity
    {
        public Guid DoctorId { get; set; }
        public Guid TrialExperienceId { get; set; }
        public Guid EvaluationCriteriaId { get; set; }

        [ForeignKey("EvaluationCriteriaId")]
        public Dictionary EvaluationCriteria { get; set; }



    }
}