using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("TrialPaymentPrice")]
    public partial class TrialPaymentPrice : Entity, IAuditAdd, IAuditUpdate
    {
        public Guid TrialId { get; set; }

        public Trial Trial { get; set; }

        [Column(TypeName = "decimal(18,2)")]
        public decimal TrialAdditional { get; set; } = 0;

        public string SowName { get; set; } = string.Empty;
        public string SowPath { get; set; } = string.Empty;

        [Column(TypeName = "decimal(18,2)")]
        public decimal AdjustmentMultiple { get; set; } = 1;



        /// <summary>
        /// Ƿ ΪĿ
        /// </summary>
        public bool? IsNewTrial { get; set; } = false;

        public DateTime CreateTime { get; set; }
        public Guid CreateUserId { get; set; }
        public DateTime UpdateTime { get; set; }
        public Guid UpdateUserId { get; set; }
    }
}
