﻿using System;

namespace IRaCIS.Core.Domain.Models
{
    public class TrialRevenuesPriceVerification : Entity
    {
        public Guid TrialId { get; set; }

        public Guid ReviewerId { get; set; }

        public string YearMonth { get; set; }

        public bool Training { get; set; } = false;

        public bool Downtime { get; set; } = false;

        public bool Global { get; set; } = false;

        public bool Timepoint { get; set; } = false;

        public bool TimepointIn24H { get; set; } = false;

        public bool TimepointIn48H { get; set; } = false;

        public bool Adjudication { get; set; } = false;

        public bool AdjudicationIn24H { get; set; } = false;

        public bool AdjudicationIn48H { get; set; } = false;
        public bool RefresherTraining { get; set; } = false;
        public DateTime WorkLoadDate { get; set; }
    }
}