﻿using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    public class StudyDTF  : Entity, IAuditAdd
    {
        [ForeignKey("StudyId")]
        public DicomStudy DicomStudy { get; set; }
        public Guid StudyId { get; set; } = Guid.Empty;

        public string FileName { get; set; } = string.Empty;

        public string Path { get; set; } = string.Empty;


        //public byte[] RowVersion { get; set; } = default;

        
        public Guid CreateUserId { get; set; }
        public DateTime CreateTime { get; set; } = DateTime.Now;
    }
}