﻿using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("StudyReviewer")]
    public class StudyReviewer : Entity,  IAuditAdd
    {
        public Guid StudyId { get; set; }
        public Guid ReviewerId { get; set; }

        public Guid TrialId { get; set; }

        // 2是 ad  1是tp
        public int WorkloadType { get; set; } = 0;
        public int Status { get; set; } = 30;
        public Guid CreateUserId { get; set; }
        public DateTime CreateTime { get; set; } = DateTime.Now;
    }
}
