using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("Role")]
    public partial class Role : Entity, IAuditUpdate, IAuditAdd
    {

        public string RoleName { get; set; } = string.Empty;

        public string RoleDescription { get; set; } = string.Empty;

        public int Status { get; set; }
        public int PrivilegeLevel { get; set; } //Ȩ޼

        public DateTime CreateTime { get; set; } = DateTime.Now;
        public Guid CreateUserId { get; set; } = Guid.Empty;
        public DateTime UpdateTime { get; set; } = DateTime.Now;
        public Guid UpdateUserId { get; set; } = Guid.Empty;
    }
}
