﻿using System;
using System.Collections.Generic;
using IRaCIS.Core.Domain.Share;

namespace IRaCIS.Core.Domain.Models
{
    public class UserType:Entity
    {
        //public Guid RoleId { get; set; }
        //public List<TrialUser> TrialUserList { get; set; }



        public UserTypeEnum UserTypeEnum { get; set; }
       
        public string UserTypeName { get; set; }

        public string Description { get; set; }

        public int  Order { get; set; }

        public string UserTypeShortName { get; set; } = string.Empty;

        public bool IsEnable { get; set; } = true;


        public string PermissionStr { get; set; }




        public List<UserTypeMenu> UserTypeMenuList { get; set; }

        public List <UserTypeGroup> UserTypeGroupList { get; set; }

        public List<SystemDocNeedConfirmedUserType> SystemDocNeedConfirmedUserTypeList { get; set; }

        public List<User> UserList { get; set; }




        //public bool IsInternal { get; set; }
        //public UserTypeGroup Type { get; set; }
    }
}