﻿using IRaCIS.Core.Domain.Models;
using IRaCIS.Core.Domain.Share;
using System;
using System.Collections.Generic;
using System.Text;

namespace IRaCIS.Core.Domain.Models
{
  
    public class CheckChallengeDialog : Entity, IAuditAdd
    {
        public string TalkContent { get; set; } = string.Empty;

       public SubjectVisit SubjectVisit { get; set; }
        public Guid SubjectVisitId { get; set; }

        public User CreateUser { get; set; }

        public DateTime CreateTime { get; set; } = DateTime.Now;
        public Guid CreateUserId { get; set; } = Guid.Empty;

        public UserTypeEnum UserTypeEnum { get; set; }

        // 
        public bool? IsCRCNeedReply { get; set; }
    }
}
