
using System;
using IRaCIS.Core.Domain.Share;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace IRaCIS.Core.Domain.Models
{
	 ///<summary>
	 /// 阅片医学问题答案
	 ///</summary>
	 [Table("ReadingMedicineQuestionAnswer")]	
	 public class ReadingMedicineQuestionAnswer : Entity, IAuditUpdate, IAuditAdd
	 {


		/// <summary>
		/// 医学审核问题Id
		/// </summary>
		public Guid ReadingMedicineQuestionId { get; set; }
		
		/// <summary>
		/// 医学审核Id
		/// </summary>

		public Guid TaskMedicalReviewId { get; set; }
	
		/// <summary>
        /// 任务Id
        /// </summary>
	
		public Guid VisitTaskId { get; set; }
	
		/// <summary>
        /// 答案
        /// </summary>
		
		public string Answer { get; set; }
	
		/// <summary>
        /// 创建人
        /// </summary>
		
		public Guid CreateUserId { get; set; }
	
		/// <summary>
        /// 创建时间
        /// </summary>
	
		public DateTime CreateTime { get; set; }
	
		/// <summary>
        /// 修改时间
        /// </summary>
		
		public DateTime UpdateTime { get; set; }
	
		/// <summary>
        /// 修改人
        /// </summary>
	
		public Guid UpdateUserId { get; set; }
	 
	 }


}	 
