﻿using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("TrialAttachment")]
    public class TrialAttachment : Entity, IAuditUpdate, IAuditAdd
    {
        public Guid TrialId { get; set; }
        public string Type { get; set; } = String.Empty;
        public string DocumentName { get; set; } = String.Empty;
        public string DocumentPath { get; set; } = String.Empty;

        public string UserTypes { get; set; } = String.Empty;
        
        public DateTime CreateTime { get; set; }
        public Guid CreateUserId { get; set; }
        public DateTime UpdateTime { get; set; }
        public Guid UpdateUserId { get; set; }
    }
}
