﻿using System;
using IRaCIS.Application.Contracts;
using IRaCIS.Core.Infrastructure.Extention;

namespace IRaCIS.Application.Interfaces
{
    public class AwardPriceDTO: AwardPriceCalculateDTO
    {
        public Guid Id { get; set; }
    }

    public class AwardPriceCalculateDTO
    {
        public decimal Price { get; set; }
        public int Max { get; set; }
        public int Min { get; set; }
    }

    public class AwardPriceCommand
    {
        //public Guid Id { get; set; }
        public decimal Price { get; set; }
        public int Min { get; set; }
        public int Max { get; set; }
        public Guid OptUserId { get; set; }
    }

    public class AwardPriceQueryDTO : PageInput
    {
    }

    public class ExchangeRateQueryDTO : PageInput
    {
        public DateTime? SearchMonth { get; set; }
    }

}