﻿using IRaCIS.Application.Contracts;
using System;
using System.Collections.Generic;
using IRaCIS.Core.Infrastructure.Extention;

namespace IRaCIS.Application.Interfaces
{
    public interface ICalculateService
    {
        Task<IResponseOutput> CalculateMonthlyPayment(CalculateDoctorAndMonthDTO param, string token);
        //IResponseOutput LockMonthlyPayment(LockPaymentDTO param);
        Task<List<CalculateNeededDTO>> GetNeedCalculateReviewerList(Guid reviewerId, string yearMonth);
        Task<bool> IsLock(Guid reviewerId, string yearMonth);
        //bool ResetMonthlyPayment(Guid reviewerId, Guid trialId,string yearMonth);
    }
}
