﻿using System;
using System.Collections.Generic;
using System.Text;

namespace IRaCIS.Core.Application.Contracts.Dicom.DTO
{
    public class ImageLabelDTO
    {
        public Guid Id { get; set; } = Guid.Empty;
        public string TpCode { get; set; } = string.Empty;
        public Guid StudyId { get; set; } = Guid.Empty;
        public Guid SeriesId { get; set; } = Guid.Empty;
        public Guid InstanceId { get; set; } = Guid.Empty;
        public string LabelValue { get; set; } = string.Empty;
    }
    public class ImageLabelInfo
    {
        public Guid StudyId { get; set; } = Guid.Empty;
        public Guid SeriesId { get; set; } = Guid.Empty;
        public Guid InstanceId { get; set; } = Guid.Empty;
        public string LabelValue { get; set; } = string.Empty;
    }

    public class ImageLabelCommand
    {
        public string TpCode { get; set; } = string.Empty;
        public List<ImageLabelInfo> ImageLabelList { get; set; } = new List<ImageLabelInfo>();
    }
}
