﻿using System;
using IRaCIS.Core.Infrastructure.Extention;

namespace IRaCIS.Application.Contracts
{
    public class HospitalDTO : HospitalCommand
    {

    }

    public class HospitalCommand
    {
        public Guid? Id { get; set; }
        public string HospitalName { get; set; } = String.Empty;
        public string UniversityAffiliated { get; set; } = String.Empty;
        public string Country { get; set; } = String.Empty;
        public string Province { get; set; } = String.Empty;
        public string City { get; set; } = String.Empty;


        public string HospitalNameCN { get; set; } = String.Empty;
        public string UniversityAffiliatedCN { get; set; } = String.Empty;
        public string CountryCN { get; set; } = String.Empty;
        public string ProvinceCN { get; set; } = String.Empty;
        public string CityCN { get; set; } = String.Empty;
    }

    public class HospitalQueryDTO : PageInput
    {
        public string HospitalName { get; set; } = string.Empty;
        public string Province { get; set; } = string.Empty;
        public string City { get; set; } = string.Empty;
    }
}
