﻿using System;
using System.Collections.Generic;
using IRaCIS.Application.Contracts;
using IRaCIS.Core.Infrastructure.Extention;

namespace IRaCIS.Application.Interfaces
{
    public interface ISiteService
    {
        Task<PageOutput<SiteSelectDTO>> GetSiteList(SiteQueryParam queryModel);
         Task<IEnumerable<SiteSelectionDTO>> GetAllSiteList();
        Task<IResponseOutput> AddOrUpdateSite(SiteCommand AddModel);
        Task<IResponseOutput> DeleteSite(Guid researchCenterId);


    }
}