﻿using Microsoft.AspNetCore.JsonPatch.Operations;
using Swashbuckle.AspNetCore.Filters;

namespace IRaCIS.Core.Application.Contracts
{
    /// <summary>
    /// 实测 标注在服务方法上 没用
    /// </summary>
    public class JsonPatchUserRequestExample : IExamplesProvider<object>
    {
        public Operation[] GetExamples()
        {
            return new[]
           {
                new Operation
                {
                    op = "replace",
                    path = "/name",
                        value = "Gordon"
                },
                new Operation
                {
                    op = "replace",
                    path = "/surname",
                        value = "Freeman"
                }
            };
        }

        object IExamplesProvider<object>.GetExamples()
        {
            return new[]
          {
                new Operation
                {
                    op = "replace",
                    path = "/name",
                        value = "Gordon"
                },
                new Operation
                {
                    op = "replace",
                    path = "/surname",
                        value = "Freeman"
                }
            };
        }
    }

   
}
