﻿using System;

namespace IRaCIS.Core.Domain.Models
{
    public interface IAuditAdd<TKey> where TKey: struct
    {
        TKey CreateUserId { get; set; }
 
        DateTime CreateTime { get; set; }
      
    }



    public interface IAuditAdd: IAuditAdd<Guid>
    {
       
    }

    public interface IAuditAddWithUserName : IAuditAdd<Guid>
    {
        string CreateUser { get; set; }
    }

}
