using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("SystemLog")]
    public partial class SystemLog : Entity
    {
        public string ApiPath { get; set; } = string.Empty;
        public string Params { get; set; } = string.Empty;
        public string Result { get; set; } = string.Empty;
        public DateTime RequestTime { get; set; } = DateTime.Now;
        public long ElapsedMilliseconds { get; set; } = 0;
        public Guid OptUserId { get; set; } = Guid.Empty;
        public string OptUserName { get; set; } = string.Empty;
        public string ClientIP { get; set; } = string.Empty;
        public bool Status { get; set; } = true;
        public string Message { get; set; } = string.Empty;
        public string LogCategory { get; set; } = string.Empty;
    }
}
