﻿using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("ExchangeRate")]
    public class ExchangeRate : Entity, IAuditUpdate, IAuditAdd
    {
        public string YearMonth { get; set; }

        [Column(TypeName = "decimal(18,2)")]
        public decimal Rate { get; set; }
        public Guid UpdateUserId { get; set; }
        public DateTime UpdateTime { get; set; }
        public Guid CreateUserId { get; set; }
        public DateTime CreateTime { get; set; }
    }
}
