﻿using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("KeyInstance")]
    public class KeyInstance : Entity, IAuditAdd, IAuditUpdate
    {

        public string TpCode { get; set; }
        public Guid SeriesId { get; set; }
        public Guid InstanceId { get; set; }
        public Guid CreateUserId { get; set; }
        public DateTime CreateTime { get; set; } = DateTime.Now;
        public Guid UpdateUserId { get; set; }
        public DateTime UpdateTime { get; set; } = DateTime.Now;
    }
}
