using System;
using System.ComponentModel.DataAnnotations.Schema;
using IRaCIS.Core.Domain.Share;

namespace IRaCIS.Core.Domain.Models
{
    [Table("UserTypeMenu")]
    public partial class UserTypeMenu : Entity
    {

        public Menu Menu { get; set; }
        public Guid UserTypeId { get; set; }
        public Guid MenuId { get; set; }

        [ForeignKey("UserTypeId")]
        public UserType UserType { get; set; }

    }
}
