﻿using IRaCIS.Core.Domain.Share;
using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    public class QCChallengeDialog : Entity, IAuditAdd
    {
        public QCChallenge QCChallenge { get; set; }
        public string TalkContent { get; set; } = string.Empty;

        public Guid QCChallengeId { get; set; }

        public Guid SubjectVisitId { get; set; }

        [ForeignKey("CreateUserId")]
        public User CreateUser { get; set; } 

        public DateTime CreateTime { get; set; } = DateTime.Now;
        public Guid CreateUserId { get; set; } = Guid.Empty;

        public UserTypeEnum UserTypeEnum { get; set; }
    }
}