﻿using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    public class TrialAudit:Entity
    {
        public int AuditType { get; set; }

        public Guid TrialId { get; set; }

        public Guid StudyId { get; set; } = Guid.Empty;

        public Guid? SubjectId { get; set; }

        public Guid OptUserId { get; set; }

        public string OptUser { get; set; }

        public DateTime OptTime { get; set; }=DateTime.Now;
        public string Note { get; set; }

        public string Detail { get; set; }

        [ForeignKey("SubjectId")]
        public Subject Subject { get; set; }
        public Trial Trial { get; set; }
    }
}